package dev.shadowsoffire.apotheosis.adventure.affix.augmenting;

import net.minecraft.ChatFormatting;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.network.chat.Component;
import java.util.List;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.entity.BlockEntity;
import dev.shadowsoffire.placebo.menu.MenuUtil;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.phys.BlockHitResult;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.shapes.CollisionContext;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.phys.shapes.VoxelShape;
import dev.shadowsoffire.placebo.block_entity.TickingEntityBlock;
import net.minecraft.world.level.block.Block;

public class AugmentingTableBlock extends Block implements TickingEntityBlock
{
    public static final VoxelShape SHAPE;
    
    public AugmentingTableBlock(final BlockBehaviour.Properties pProperties) {
        super(pProperties);
    }
    
    public boolean m_7923_(final BlockState pState) {
        return true;
    }
    
    public VoxelShape m_5940_(final BlockState pState, final BlockGetter pLevel, final BlockPos pPos, final CollisionContext pContext) {
        return AugmentingTableBlock.SHAPE;
    }
    
    public InteractionResult m_6227_(final BlockState state, final Level world, final BlockPos pos, final Player player, final InteractionHand handIn, final BlockHitResult hit) {
        return MenuUtil.openGui(player, pos, AugmentingMenu::new);
    }
    
    public BlockEntity m_142194_(final BlockPos pPos, final BlockState pState) {
        return new AugmentingTableTile(pPos, pState);
    }
    
    public void m_5871_(final ItemStack pStack, final BlockGetter pLevel, final List<Component> list, final TooltipFlag pFlag) {
        list.add((Component)Component.m_237115_(this.m_7705_() + ".desc").m_130940_(ChatFormatting.GRAY));
    }
    
    @Deprecated
    public void m_6810_(final BlockState state, final Level world, final BlockPos pos, final BlockState newState, final boolean isMoving) {
        final BlockEntity te = world.m_7702_(pos);
        if (te instanceof final AugmentingTableTile ref) {
            for (int i = 0; i < ref.inv.getSlots(); ++i) {
                m_49840_(world, pos, ref.inv.getStackInSlot(i));
            }
        }
        super.m_6810_(state, world, pos, newState, isMoving);
    }
    
    static {
        SHAPE = Block.m_49796_(0.0, 0.0, 0.0, 16.0, 12.0, 16.0);
    }
}
